
procedure pdmstodd(pdms: real; var dd :real);
{ convert an angle expressed in packed form degrees, minutes and seconds
  (dddmmss.ss) to decimal degrees (dd.dddd) }
var
  ddd, mstemp, mm, ddsec, ddmin : real;
begin
  ddd := abs(trunc(pdms / 10000.00));
  mstemp := (abs(pdms) - 10000.00 * ddd) / 100.00;
  mm := trunc( mstemp );
  ddsec := (mstemp - mm) / 36.00;
  ddmin := mm / 60.00;
  dd := ddd + ddmin + ddsec;
  if (pdms < 0.00) then
     dd := -dd ;
end;
