/*
*  Windat -- window data structures for NCSA Telnet
****************************************************************************
*                                                                          *
*                                                                          *
*      NCSA Telnet                                                         *
*      by Tim Krauskopf, VT100 by Gaige Paulsen, Tek by Aaron Contorer     *
*                                                                          *
*      National Center for Supercomputing Applications                     *
*      152 Computing Applications Building                                 *
*      605 E. Springfield Ave.                                             *
*      Champaign, IL  61820                                                *
*                                                                          *
*                                                                          *
****************************************************************************
*  Tim Krauskopf
*
*  structure to save capabilities of windows, in addition to the
*  virtual vt102 screen driver.
*/
/*  
*  terminal modes, can be changed by external program
*  VTEK is a VT terminal that can accept graphics
*  TEK  is a tek graphics mode for a VT
*  VT   is a VT-only type, cannot be changed to graphics mode 
*/
#define DUMBTYPE 2
#define VTEKTYPE 1
#define TEKTYPE 4
#define VTTYPE 3
#define RASTYPE 5

#define NCOLORS 4

struct twin {
	unsigned short colors[NCOLORS];
	unsigned char 
		mname[16],				/* name of the machine connected to */
		linemode[82];			/* line mode buffer for session */
	int pnum,					/* port number associated */
	vs,							/* virtual screen associated with it */
	telstate,					/* telnet state for this connection */
	termstate,					/* terminal type for this connection */
	teks,						/* tektronix window number */
	binary,						/* negotiate for binary traffic */
	igoahead,					/* negotiation for suppress go-ahead */
	ugoahead,					/* neg. for his suppress go-ahead */
	echo,						/* line mode or echo mode? */
	halfdup,					/* half duplex mode overrides line mode */
	crfollow,					/* what is supposed to follow a CR? NUL or LF? */
	capon,						/* does this session own a capture file? */
	sstat,						/* stat box on screen */
	bksp,						/* what keycode for backspace ?*/
	del;						/* for delete? */
	FILE *capfp;
	struct twin *next,*prev;
};

#ifdef WINMASTER
	struct twin *screens[30],*current=NULL,*console,*curdisp=NULL,
		*wins[NPORTS];
#else
	extern struct twin *screens[30],*current,*console,*curdisp,
		*wins[NPORTS];
#endif
